<?php

/***
 * This software is intended for use with Oxdate Free Dating Software
 * http://www.oxdate.org/ and is licensed under The BSD license.
 * Full text of this license can be found at http://www.oxdate.org/license

 * =============================================================================
 * Copyright (c) 2016 Oxdate.org - All rights reserved.
 * =============================================================================

 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that the
 * following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
   the following disclaimer in the documentation and/or other materials provided with the distribution.
 * Neither the name of the Oxdate Foundation nor the names of its contributors may be used to endorse or promote products
   derived from this software without specific prior written permission.

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
***/

class HOTLIST_MCMP_Widget extends BASE_MCMP_UserListWidget
{

    public function __construct(BASE_CLASS_WidgetParameter $params)
    {
        parent::__construct($params);
    }

    public static function getStandardSettingValueList()
    {
        $list = array(
            self::SETTING_TITLE => OW::getLanguage()->text('hotlist', 'userlist'),
            self::SETTING_SHOW_TITLE => true,
            self::SETTING_ICON => 'ow_ic_heart',
            self::SETTING_WRAP_IN_BOX => true,
            self::SETTING_SHOW_TITLE => true,
        );

        return $list;
    }

    public static function getSettingList()
    {
        $settingList['number_of_users'] = array(
            'presentation' => self::PRESENTATION_NUMBER,
            'label' => OW::getLanguage()->text('hotlist', 'cmp_widget_number_of_users'),
            'value' => 8,
        );

        return $settingList;
    }

    public function getData( BASE_CLASS_WidgetParameter $params )
    {
        $count = (int) $params->customParamList['number_of_users'];
        $service = HOTLIST_BOL_Service::getInstance();

        $toolbar = array(
                    'label' => OW::getLanguage()->text('base', 'view_all'),
                    'href' => OW::getRouter()->urlForRoute('hotlist-list')
                );

        $this->setSettingValue(self::SETTING_TOOLBAR, array($toolbar));
        
        $list = $service->getHotList(0, $count);
        $userIdList = array();
        
        /* @var $value HOTLIST_BOL_User */
        foreach( $list as $value ) {
            $userIdList[$value->userId] = $value->userId;
        }

        $resultList = array(
            'hotlist' => array(
                'menu-label' => " ",
                'menu_active' => true,
                'userIds' => $userIdList,
                'toolbar' => $toolbar,
            ));

        return $resultList;
    }
    
    public static function getAccess()
    {
        return self::ACCESS_MEMBER;
    }

}
