<?php

/***
 * This software is intended for use with Oxdate Free Dating Software
 * http://www.oxdate.org/ and is licensed under The BSD license.
 * Full text of this license can be found at http://www.oxdate.org/license

 * =============================================================================
 * Copyright (c) 2016 Oxdate.org - All rights reserved.
 * =============================================================================

 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that the
 * following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
   the following disclaimer in the documentation and/or other materials provided with the distribution.
 * Neither the name of the Oxdate Foundation nor the names of its contributors may be used to endorse or promote products
   derived from this software without specific prior written permission.

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
***/

class OXDATE_CTRL_Admin extends ADMIN_CTRL_Abstract
{
    /**
     * @var OXDATE_BOL_Service
     */
    private $service;

    public function __construct()
    {
        parent::__construct();
        $this->service = OXDATE_BOL_Service::getInstance();
    }

    public function uninstall()
    {
        
    }

    public function settings()
    {
        $language = OW::getLanguage();
        $config = OW::getConfig();
        $licenseInfo = json_decode($config->getValue('oxdate', 'license_info'), true);

        $licenseKey = $config->getValue('oxdate', 'license_key');
        $branding = $config->getValue('oxdate', 'brand_removal');
        $this->assign('data', array(
            $language->text('oxdate', 'info_name_label') => array_key_exists('registeredname', $licenseInfo) ? $licenseInfo['registeredname'] : 'None',
            $language->text('oxdate', 'info_lkey_label') => $licenseKey,
            $language->text('oxdate', 'info_domain_label') => array_key_exists('validdomain', $licenseInfo) ? $licenseInfo['validdomain'] : 'None',
            $language->text('oxdate', 'info_ip_label') => array_key_exists('validip', $licenseInfo) ? $licenseInfo['validip'] : 'None',
            $language->text('oxdate', 'info_dir_label') => array_key_exists('validdirectory', $licenseInfo) ? $licenseInfo['validdirectory'] : 'None',
            $language->text('oxdate', 'info_brand_label') => $branding ? 'Yes' : 'No',
            $language->text('oxdate', 'info_created_label') => array_key_exists('regdate', $licenseInfo) ? $licenseInfo['regdate'] : 'None',
            $language->text('oxdate', 'info_expires_label') => array_key_exists('nextduedate', $licenseInfo) ? $licenseInfo['nextduedate'] : 'None'
        ));
    }

    public function invalidKey()
    {
        if ( isset($_GET['check']) )
        {
            if ( !empty($_GET['key']) )
            {
                OW::getConfig()->saveConfig('oxdate', 'license_key', trim($_GET['key']));
            }

            OXDATE_BOL_LicenceService::getInstance()->validateKey();

            if ( !(bool) OW::getConfig()->getValue('oxdate', 'license_key_valid') )
            {
                OW::getFeedback()->error(OW::getLanguage()->text('oxdate', 'validation_failed'));
            }

            $this->redirect(OW::getRequest()->buildUrlQueryString(null, array('check' => null)));
        }

        if ( strlen(trim(OW::getConfig()->getValue('oxdate', 'license_key'))) < 1 )
        {
            $this->assign('input', 1);
        }

        $this->assign('url', OW::getRequest()->buildUrlQueryString(null, array('check' => 1)));
    }
}
