<?php
/***
 * This software is intended for use with Oxdate Free Dating Software
 * http://www.oxdate.org/ and is licensed under The BSD license.
 * Full text of this license can be found at http://www.oxdate.org/license

 * =============================================================================
 * Copyright (c) 2016 Oxdate.org - All rights reserved.
 * =============================================================================

 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that the
 * following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
   the following disclaimer in the documentation and/or other materials provided with the distribution.
 * Neither the name of the Oxdate Foundation nor the names of its contributors may be used to endorse or promote products
   derived from this software without specific prior written permission.

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
***/
class PROTECTEDPHOTOS_BOL_AccessDao extends OW_BaseDao
{
    const PASSWORD_ID = 'passwordId';
    const USER_ID = 'userId';

    private static $instance;

    public static function getInstance()
    {
        if ( null === self::$instance )
        {
            self::$instance = new self();
        }

        return self::$instance;
    }

    public function getTableName()
    {
        return OW_DB_PREFIX . 'protectedphotos_accesses';
    }

    public function getDtoClassName()
    {
        return 'PROTECTEDPHOTOS_BOL_Access';
    }

    public function findByPasswordIdsAndUserId( array $passwordIds, $userId )
    {
        if ( count($passwordIds) === 0 || empty($userId) )
        {
            return array();
        }

        $example = new OW_Example();
        $example->andFieldInArray(self::PASSWORD_ID, $passwordIds);
        $example->andFieldEqual(self::USER_ID, $userId);

        return $this->findListByExample($example);
    }

    /**
     * @param int $passwordId
     * @param int $userId
     * @return PROTECTEDPHOTOS_BOL_Access
     */
    public function findByPasswordIdAndUserId( $passwordId, $userId )
    {
        if ( empty($passwordId) || empty($userId) )
        {
            return null;
        }

        $example = new OW_Example();
        $example->andFieldEqual(self::PASSWORD_ID, $passwordId);
        $example->andFieldEqual(self::USER_ID, $userId);

        return $this->findObjectByExample($example);
    }

    public function deleteAccessByPasswordId( $passwordId )
    {
        if ( empty($passwordId) )
        {
            return null;
        }

        $example = new OW_Example();
        $example->andFieldEqual(self::PASSWORD_ID, $passwordId);

        return $this->deleteByExample($example);
    }

    public function deleteAccessForUser( $passwordId, $userId )
    {
        if ( empty($passwordId) || empty($userId) )
        {
            return null;
        }

        $example = new OW_Example();
        $example->andFieldEqual(self::PASSWORD_ID, $passwordId);
        $example->andFieldEqual(self::USER_ID, $userId);

        return $this->deleteByExample($example);
    }
}
