<?php

/***
 * This software is intended for use with Oxdate Free Dating Software
 * http://www.oxdate.org/ and is licensed under The BSD license.
 * Full text of this license can be found at http://www.oxdate.org/license

 * =============================================================================
 * Copyright (c) 2016 Oxdate.org - All rights reserved.
 * =============================================================================

 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that the
 * following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
   the following disclaimer in the documentation and/or other materials provided with the distribution.
 * Neither the name of the Oxdate Foundation nor the names of its contributors may be used to endorse or promote products
   derived from this software without specific prior written permission.

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
***/
class WINKS_MCMP_ConsoleSection extends OW_MobileComponent
{
    private $service;
    private $count;

    public function __construct()
    {
        parent::__construct();

        $this->service = WINKS_BOL_Service::getInstance();

        $userId = OW::getUser()->getId();
        $activeModes = $this->service->getActiveModes();

        $count = array(
            $this->service->countWinksForUser($userId, array(WINKS_BOL_WinksDao::STATUS_ACCEPT, WINKS_BOL_WinksDao::STATUS_WAIT), null, $activeModes),
            $this->service->countWinkBackedByUserId($userId, $activeModes)
        );

        $this->count = max($count);

        if ( $this->count <= 0 )
        {
            $this->setVisible(false);
        }
    }

    public function onBeforeRender()
    {
        parent::onBeforeRender();

        $this->addComponent('itemsCmp', new WINKS_MCMP_ConsoleItems($this->count));

        OW::getDocument()->addScript(OW::getPluginManager()->getPlugin('winks')->getStaticJsUrl() . 'mobile.js');
        OW::getDocument()->addOnloadScript(UTIL_JsGenerator::composeJsString(';new OWM_WinksConsole({$params});', array(
            'params' => array(
                'acceptUrl' => OW::getRouter()->urlFor('WINKS_MCTRL_Action', 'accept'),
                'ignoreUrl' => OW::getRouter()->urlFor('WINKS_MCTRL_Action', 'ignore')
            )
        )));
    }
}
